
// 12-01-2018
// usefull links :
// https://github.com/Nkawu/TFT_22_ILI9225/wiki
// TFT_22_ILI9225_mbed.cpp
// adatation pour PIC18F et MikroC by paulfjujo

#include "TFT_ILI9225_SPI_2018.h"

// Control pins
    #define SPI_DC_HIGH()           _RS=1
    #define SPI_DC_LOW()            _RS=0
    #define SPI_CS_HIGH()           _CS=1
    #define SPI_CS_LOW()            _CS=0

 #ifndef pgm_read_byte
// #define pgm_read_byte(addr) (*(const unsigned char *)(addr))
 // #define pgm_read_byte(addr) (*( unsigned char *)(addr))
#endif

extern char CRam1[];
extern void Print_Cte_String(const char*);
extern void UART1_Write_Text(char * );
extern void CRLF1();
extern char Debug_Font;
extern unsigned int textColor,bgColor  ;
extern unsigned int textBgcolor,_maxX,_maxY  ;
extern unsigned char * pp;
extern unsigned char  Table[];

    // Hardware SPI
 void TFT_Init()
 {
  // Pull the reset pin high to release the ILI9225C from the reset status
      Delay_1sec();
      _RST=1;
      Delay_1sec();
      _RST=0;
      Delay_1sec();
      _RST=1;
   // Start Initial Sequence
   //   SQ50_trigger=1;
    _CS=1;
      Delay_1sec();
      
    _writeRegister(ILI9225_POWER_CTRL1, 0x0000); // Set SAP,DSTB,STB    R10
    _writeRegister(ILI9225_POWER_CTRL2, 0x0000); // Set APON,PON,AON,VCI1EN,VC R11
    _writeRegister(ILI9225_POWER_CTRL3, 0x0000); // Set BT,DC1,DC2,DC3  R12
    _writeRegister(ILI9225_POWER_CTRL4, 0x0000); // Set GVDD            R13
    _writeRegister(ILI9225_POWER_CTRL5, 0x0000); // Set VCOMH/VCOML voltage  R14
    Delay_ms(50);

    // Power-on sequence
    _writeRegister(ILI9225_POWER_CTRL2, 0x0018); // Set APON,PON,AON,VCI1EN,VC
    _writeRegister(ILI9225_POWER_CTRL3, 0x6121); // Set BT,DC1,DC2,DC3
    _writeRegister(ILI9225_POWER_CTRL4, 0x006F); // Set GVDD   007F 0088
    _writeRegister(ILI9225_POWER_CTRL5, 0x495F); // Set VCOMH/VCOML voltage
    _writeRegister(ILI9225_POWER_CTRL1, 0x0800); // Set SAP,DSTB,STB     //VO
    Delay_ms(20);
    _writeRegister(ILI9225_POWER_CTRL2, 0x103B); // Set APON,PON,AON,VCI1EN,VC
    Delay_ms(50);

    _writeRegister(ILI9225_DRIVER_OUTPUT_CTRL, 0x011C); // set the display line number and display direction
    _writeRegister(ILI9225_LCD_AC_DRIVING_CTRL, 0x0100); // set 1 line inversion
    _writeRegister(ILI9225_ENTRY_MODE, 0x1030); // set GRAM write direction and BGR=1.
    _writeRegister(ILI9225_DISP_CTRL1, 0x0000); // Display off
   // _writeRegister(ILI9225_BLANK_PERIOD_CTRL1, 0x0202); // set the back porch and front porch
    _writeRegister(ILI9225_BLANK_PERIOD_CTRL1, 0x0808); // set the back porch and front porch
     _writeRegister(ILI9225_FRAME_CYCLE_CTRL, 0x1100); // set the clocks number per line
    _writeRegister(ILI9225_INTERFACE_CTRL, 0x0000); // CPU interface
    _writeRegister(ILI9225_OSC_CTRL, 0x0D01); // Set Osc  /*0e01*/
    // _writeRegister(ILI9225_OSC_CTRL, 0x07D01); // Set Osc  66Hz  and Enable OSC/
    _writeRegister(ILI9225_VCI_RECYCLING, 0x0020); // Set VCI recycling
    _writeRegister(ILI9225_RAM_ADDR_SET1, 0x0000); // RAM Address
    _writeRegister(ILI9225_RAM_ADDR_SET2, 0x0000); // RAM Address

    /* Set GRAM area */
    _writeRegister(ILI9225_GATE_SCAN_CTRL, 0x0000); 
    _writeRegister(ILI9225_VERTICAL_SCROLL_CTRL1, 0x00DB);   //219
    _writeRegister(ILI9225_VERTICAL_SCROLL_CTRL2, 0x0000); 
    _writeRegister(ILI9225_VERTICAL_SCROLL_CTRL3, 0x0000); 
    _writeRegister(ILI9225_PARTIAL_DRIVING_POS1, 0x00DB); 
    _writeRegister(ILI9225_PARTIAL_DRIVING_POS2, 0x0000); 
    _writeRegister(ILI9225_HORIZONTAL_WINDOW_ADDR1, 0x00AF);  //175
    _writeRegister(ILI9225_HORIZONTAL_WINDOW_ADDR2, 0x0000); 
    _writeRegister(ILI9225_VERTICAL_WINDOW_ADDR1, 0x00DB); 
    _writeRegister(ILI9225_VERTICAL_WINDOW_ADDR2, 0x0000); 
    /* Set GAMMA curve */
    _writeRegister(ILI9225_GAMMA_CTRL1, 0x0000);
    _writeRegister(ILI9225_GAMMA_CTRL2, 0x0808);
    _writeRegister(ILI9225_GAMMA_CTRL3, 0x080A); 
    _writeRegister(ILI9225_GAMMA_CTRL4, 0x000A); 
    
    _writeRegister(ILI9225_GAMMA_CTRL5, 0x0A08); 
    _writeRegister(ILI9225_GAMMA_CTRL6, 0x0808); 
    _writeRegister(ILI9225_GAMMA_CTRL7, 0x0000); 
    _writeRegister(ILI9225_GAMMA_CTRL8, 0x0A00); 
    _writeRegister(ILI9225_GAMMA_CTRL9, 0x0710); 
    _writeRegister(ILI9225_GAMMA_CTRL10, 0x0710); 

    _writeRegister(ILI9225_DISP_CTRL1, 0x0012); 
    Delay_ms(50);
    _writeRegister(ILI9225_DISP_CTRL1, 0x1017);
    // Turn on backlight
    SetBacklight(1);
    SetOrientation(0);
    // Initialize variables
    SetBackgroundColor( COLOR_BLACK );
    FillRectangle(0,0,ILI9225_LCD_WIDTH-1,ILI9225_LCD_HEIGHT-1,COLOR_BLACK);
    _CS=0;
}


void SetTextColor(uint16_t c, uint16_t b)
{
textColor   = c;
textBgcolor = b;
}

void OrientCoordinates(uint16_t x1, uint16_t y1)
 {
    switch (_orientation) {
    case 0:  // ok
        break;
    case 1: // ok
        y1 = _maxY - y1 - 1;
        Swaping(x1,y1);
        break;
    case 2: // ok
        x1 = _maxX - x1 - 1;
        y1 = _maxY - y1 - 1;
        break;
    case 3: // ok
        x1 = _maxX - x1 - 1;
        Swaping(x1, y1);
        break;
    }
}


void SetWindow(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1)
 {
    OrientCoordinates(x0, y0);
    OrientCoordinates(x1, y1);
    if (x1<x0) Swaping(x0, x1);
    if (y1<y0) Swaping(y0, y1);
    _writeRegister(ILI9225_HORIZONTAL_WINDOW_ADDR1,x1);
    _writeRegister(ILI9225_HORIZONTAL_WINDOW_ADDR2,x0);
    _writeRegister(ILI9225_VERTICAL_WINDOW_ADDR1,y1);
    _writeRegister(ILI9225_VERTICAL_WINDOW_ADDR2,y0);
    _writeRegister(ILI9225_RAM_ADDR_SET1,x0);
    _writeRegister(ILI9225_RAM_ADDR_SET2,y0);
    _spiWriteCommand(ILI9225_GRAM_DATA_REG);
    _writeCommand(0x00, 0x22);

}

void FillRectangle(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color1)
 {  uint16_t t ;
    SetWindow(x1, y1, x2, y2);
    t=(y2 - y1 + 1) * (x2 - x1 + 1);
    do
    {
     _writeData(color1 >> 8, color1);
     t--;
     }while(t>0);
}

void Clear_TFT() 
{
    uint8_t old = _orientation;
    SetOrientation(0);
     FillRectangle(0,0,ILI9225_LCD_WIDTH-1,ILI9225_LCD_HEIGHT-1,COLOR_BLACK);
    SetOrientation(old);
    Delay_ms(10);
}

void Invert(char flag) 
{
    StartWrite();
    _writeCommand(0x00, flag ? ILI9225C_INVON : ILI9225C_INVOFF);
    EndWrite();
}


void SetBacklight(char flag) {
    blState = flag;
 //   if (_led) analogWrite(_led, blState ? _brightness : 0);
}

void SetBacklightBrightness(uint8_t bright)
{
    _brightness = bright;
    SetBacklight(blState);
}

void SetDisplay(char flag)
{
    if (flag) {
        StartWrite();
        _writeRegister(0x00ff, 0x0000);
        _writeRegister(ILI9225_POWER_CTRL1, 0x0000);
        EndWrite();
        Delay_ms(50);
        StartWrite();
        _writeRegister(ILI9225_DISP_CTRL1, 0x1017);
        EndWrite();
        Delay_ms(200);
    } else {
        StartWrite();
        _writeRegister(0x00ff, 0x0000);
        _writeRegister(ILI9225_DISP_CTRL1, 0x0000);
        EndWrite();
        Delay_ms(50);
        StartWrite();
        _writeRegister(ILI9225_POWER_CTRL1, 0x0003);
        EndWrite();
        Delay_ms(200);
    }
}

void DrawFastHLine(int16_t x, int16_t y, int16_t w, uint16_t color)
{
// Rudimentary clipping
  if((x >= ILI9225_LCD_WIDTH) || (y >= ILI9225_LCD_HEIGHT)) return;
  if((x+w) >= ILI9225_LCD_WIDTH)  w = ILI9225_LCD_WIDTH -x;
  SetAddrWindow(x, y, x+w, y);
  while (w-- > 0)
 _writeData16(color);
}


SetAddrWindow(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1)
{
 StartWrite();
 _writeRegister(ILI9225_HORIZONTAL_WINDOW_ADDR1, x1);
 _writeRegister(ILI9225_HORIZONTAL_WINDOW_ADDR2, x0);
 _writeRegister(ILI9225_VERTICAL_WINDOW_ADDR1 , y1);
 _writeRegister(ILI9225_VERTICAL_WINDOW_ADDR2, y0);
 _writeRegister(ILI9225_RAM_ADDR_SET1, x0);
 _writeRegister(ILI9225_RAM_ADDR_SET2, y0);
_spiWriteCommand(ILI9225_GRAM_DATA_REG);
  EndWrite();
}


void SetOrientation(uint8_t Orientation) 
{    Orientation = Orientation % 4;
    switch (Orientation) {
    case 0:
        _maxX = ILI9225_LCD_WIDTH;
        _maxY = ILI9225_LCD_HEIGHT;
        break;
    case 1:
        _maxX = ILI9225_LCD_HEIGHT;
        _maxY = ILI9225_LCD_WIDTH;
        break;
    case 2:
        _maxX = ILI9225_LCD_WIDTH;
        _maxY = ILI9225_LCD_HEIGHT;
        break;
    case 3:
        _maxX = ILI9225_LCD_HEIGHT;
        _maxY = ILI9225_LCD_WIDTH;
        break;
    }
}

uint8_t GetOrientation()
 {
    return _orientation;
}


uint16_t maxX2() {
    return _maxX;
}

uint16_t maxY2() {
    return _maxY;
}

uint16_t SetColor(uint8_t red8, uint8_t green8, uint8_t blue8) {
    // rgb16 = red5 green6 blue5
    return (red8 >> 3) << 11 | (green8 >> 2) << 5 | (blue8 >> 3);
}

void SplitColor(uint16_t rgb, uint8_t red, uint8_t green, uint8_t blue)
 {
    // rgb16 = red5 green6 blue5
    red   = (rgb & 0b1111100000000000) >> 11 << 3;
    green = (rgb & 0b0000011111100000) >>  5 << 2;
    blue  = (rgb & 0b0000000000011111)       << 3;
}

void Swaping(uint16_t a, uint16_t b)
 {
    uint16_t w = a;
    a = b;
    b = w;
}

void _spiWriteCommand(uint8_t c)
{
    SPI_DC_LOW();     // DC=0=Command
    SPI_CS_LOW();
    SPI1_Write(c);
    SPI_CS_HIGH();

}

void _spiWriteData(uint8_t c)
 {
    SPI_DC_HIGH();   //DC=1=Data
    SPI_CS_LOW();
    SPI1_Write(c);
    SPI_CS_HIGH();
}

// Utilities
void _writeCommand(uint8_t H1, uint8_t L1) {
     SPI_DC_LOW();     // DC=0=Command
      SPI_CS_LOW();
     SPI1_Write(H1);
     SPI1_Write(L1);
      SPI_CS_HIGH();
}

void _writeData(uint8_t H1, uint8_t L1) 
{
     SPI_DC_HIGH();
     SPI_CS_LOW();
      SPI1_Write(H1);
     SPI1_Write(L1);
     SPI_CS_HIGH();
}

void _writeData16(uint16_t W)
{
     SPI_DC_HIGH();
     SPI_CS_LOW();
      SPI1_Write(W>>8);
     SPI1_Write(W & 0x00FF);
     SPI_CS_HIGH();
}


void _writeRegister(uint16_t r, uint16_t d)    // r Regsiter  d  Data
{   
     SPI_DC_LOW();     // DC=0=Command
     SPI_CS_LOW();
     SPI1_Write(r>>8);
     SPI1_Write(r & 0x00FF);
     _asm NOP;
     SPI_DC_HIGH();     // DC=1=Data
     SPI1_Write(d>>8);
     SPI1_Write(d & 0x00FF);
     SPI_CS_HIGH();
}

void SetBackgroundColor(uint16_t color) {
    bgColor = color;
}

void SetFont( unsigned char * font)
 {
    cfont.font       = font;
    cfont.width    = *(font);
    cfont.height   = *(font+1);
    cfont.offset   = *(font+2);
    cfont.numchars = *(font+3);
    cfont.MaxC     = *(font+4);
    cfont.nbrows   = cfont.height >>3 ; // / 8;
    if (cfont.height % 8) cfont.nbrows++;  // Set number of bytes used by height of font in multiples of 8
}

void DrawText(uint16_t x, uint16_t y, char * s, uint16_t color)
 {
    uint16_t currx = x;
    uint8_t m;
    unsigned int k,l;
    l=strlen(s);
    if (l>= cfont.MaxC)l= cfont.MaxC;
    // Print every character in string
    for (k = 0; k < l; k++) 
    {
       m= DrawChar(currx, y, *(s+k), color);
       currx=currx  + m + 1;
    }
}

unsigned char DrawChar(uint16_t x, uint16_t y, unsigned char ch, uint16_t color)
 {
    uint8_t charData=0;
    uint8_t  charWidth=0;
    uint8_t  h, i, j,k;
    unsigned char cx=0;
    uint16_t charOffset=0;
   _CS=0;
   //10-01-2018 add this line below
   charOffset= (cfont.width * cfont.nbrows )+ 1;  // bytes used by each character
   charOffset =(charOffset * (ch - cfont.offset)) + FONT_HEADER_SIZE;  // char offset (add 4 for font header)
   charWidth = *(cfont.font+charOffset);
   charOffset++;  // increment pointer to first character data byte
 
   /*
   if(Debug_Font==1)
   {
   Print_Cte_String("char= " ) ;
   UART1_Write(ch);
   Print_Cte_String("  charWidth= " ) ;
   ByteToStr( charWidth,CRam1);
   UART1_Write_Text(CRam1);
   Print_Cte_String("  charOffset= " ) ;
   ByteToStr( charOffset,CRam1);
   UART1_Write_Text(CRam1);
   Print_Cte_String("   cfont.nbrows= " );
   ByteToStr( cfont.nbrows,CRam1);
   UART1_Write_Text(CRam1);
    CRLF1(); CRLF1();
   }
   */
   for (i = 0; i <= charWidth; i++) // each font "column" (+1 blank column for spacing)
    {
      h = 0;  // keep track of char height
      for (j = 0; j < cfont.nbrows; j++)
      {  // each column byte
            if (i == charWidth)
             charData = 0x00; // Insert blank column
            else
            charData = *(cfont.font+charOffset);

            
            charOffset++;
            cx= charData;
            //if(Debug_Font==1)
            //{
            // ByteToHex( charData,CRam1);
            //UART1_Write_Text(CRam1);UART1_Write(' ');
            //}
            // Process every row in font character
            for (k = 0; k < 8; k++)
            {
                if (h >= cfont.height ) break;  // No need to process excess bits
                if ((cx & 0x0001)==1)       //if (bitRead(charData, k))
                 {

                // if(Debug_Font==1) {UART1_Write('*');
                 DrawPixel(x + i, y + (j * 8) + k, color);
                 }
                else
                {
                // if(Debug_Font==1) UART1_Write(' ');
                  DrawPixel(x + i, y + (j * 8) + k, bgColor);
                }
                h++;
                cx=cx>>1;
             }
         //if(Debug_Font==1) CRLF1();
         }
      }
   _CS=1;
    return charWidth;
  }


void DrawPixel(uint16_t x1, uint16_t y1, uint16_t color1)
{
   if((x1 >= _maxX) || (y1 >= _maxY)) return;
    SetWindow(x1, y1, x1+1, y1+1);
    OrientCoordinates(x1, y1);
    _writeData(color1 >> 8, color1);
}


void DrawLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color) 
{

    // Classic Bresenham algorithm
  int steep = abs((int)(y2 - y1)) > abs((int)(x2 - x1));
  //  int16_t steep = abs(y2 - y1) > abs(x2 - x1);
    int dx, dy;
    int err ;
    int ystep;
    char inTrans;
      _CS=0;
    if (steep)
    {
        Swaping(x1, y1);
        Swaping(x2, y2);
    }
    if (x1 > x2) {
        Swaping(x1, x2);
        Swaping(y1, y2);
    }
    dx = x2 - x1;
    dy = abs(y2 - y1);
    // dy = abs((int16_t)(y2 - y1));
    // err = dx >>1;
    err = dx /2;
    if (y1 < y2)
     ystep = 1;
    else 
    ystep = -1;
//    for (; x1<=x2; x1++)
    for (x1; x1<=x2; x1++)
    {
        if (steep)
         DrawPixel(y1, x1, color);
        else      
         DrawPixel(x1, y1, color);
        err -= dy;
        if (err < 0)
         {
            y1 += ystep;
            err += dx;
        }
    }
    _CS=1;
}


 void DrawRectangle(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color2)
  { _CS=0;
    DrawLine(x1, y1, x1, y2, color2);
    DrawLine(x1, y1, x2, y1, color2);
    DrawLine(x1, y2, x2, y2, color2);
    DrawLine(x2, y1, x2, y2, color2);
    _CS=1;
}

 void DrawCircle(uint16_t x0, uint16_t y0, uint16_t r1, uint16_t color4)
  {
    int16_t f = 1 - r1;
    int16_t ddF_x = 1;
    int16_t ddF_y = -2 * r1;
    int16_t x = 0;
    int16_t y = r1;
    DrawPixel(x0, y0 + r1, color4);
    DrawPixel(x0, y0-  r1, color4);
    DrawPixel(x0 + r1, y0, color4);
    DrawPixel(x0 - r1, y0, color4);
    while (x<y) 
    {
        if (f >= 0)
        {
         y--;
         ddF_y += 2;
         f += ddF_y;
        }
        x++;
        ddF_x += 2;
        f += ddF_x;
        DrawPixel(x0 + x, y0 + y, color4);
        DrawPixel(x0 - x, y0 + y, color4);
        DrawPixel(x0 + x, y0 - y, color4);
        DrawPixel(x0 - x, y0 - y, color4);
        DrawPixel(x0 + y, y0 + x, color4);
        DrawPixel(x0 - y, y0 + x, color4);
        DrawPixel(x0 + y, y0 - x, color4);
        DrawPixel(x0 - y, y0 - x, color4);
    }
}


void FillCircle(uint8_t x0, uint8_t y0, uint8_t radius, uint16_t color3) 
{
    int16_t f = 1 - radius;
    int16_t ddF_x = 1;
    int16_t ddF_y = -2 * radius;
    int16_t x = 0;
    int16_t y = radius;
    while (x<y) {
        if (f >= 0) 
        {
            y--;
            ddF_y += 2;
            f += ddF_y;
        }
        x++;
        ddF_x += 2;
        f += ddF_x;
        DrawLine(x0 + x, y0 + y, x0 - x, y0 + y, color3); // bottom
        DrawLine(x0 + x, y0 - y, x0 - x, y0 - y, color3); // top
        DrawLine(x0 + y, y0 - x, x0 + y, y0 + x, color3); // right
        DrawLine(x0 - y, y0 - x, x0 - y, y0 + x, color3); // left
    }
    FillRectangle(x0-x, y0-y, x0+x, y0+y, color3);
}